Unit FCP;

Interface

Uses
  CRT, DOS, ProfText;

Function FormatStr (S : String; Len : Byte) : String;
Function LongStr (X : LongInt; C : Byte) : String;
Function LongStr2 (X : LongInt) : String;
Function UpStr (S : String) : String;
Procedure Color (B, T : Byte);
Function CD (P : PathStr) : Boolean;
Function FN (Name : String; Dir : Boolean) : String;
Function FNH (Name : String; Dir, Hid : Boolean) : String;
Function FDN (D : String) : String;
Function Last (D : String) : String;
Function Exists (Name : PathStr) : Boolean;
Function ReadScan : Byte;
Function CMask (Mask, Name : String) : Boolean;

Implementation

Function FormatStr (S : String; Len : Byte) : String;
Begin
  While Length (S) < Len-1 do
    S := ' '+S+' ';
  If Length (S) < Len then S := S+' ';
  FormatStr := S
End;

Function LongStr (X : LongInt; C : Byte) : String;
Const Ch : Char = ',';
Var
  S : String;
  I : Byte;
Begin
  If Abs (X) < 100000000 then Str (Abs (X), S)
  Else Str (Abs (X) div 1024, S);
  If Length (S) > 3 then
    For I := 1 to Length (S) div 3 do
      Insert (Ch, S, Length (S) - I*4 + 2);
  If S[1] = Ch then S := Copy (S, 2, Length (S) - 1);
  If X < 0 then S := '-' + S;
  S := S + ' ';
  If Abs (X) >= 100000000 then S := S+'K';
  While Length (S) < C do S := ' '+S;
  LongStr := S
End;

Function LongStr2 (X : LongInt) : String;
Const Ch : Char = ',';
Var
  S : String;
  I : Byte;
Begin
  Str (Abs (X), S);
  If Length (S) > 3 then
    For I := 1 to Length (S) div 3 do
      Insert (Ch, S, Length (S) - I*4 + 2);
  If S[1] = Ch then S := Copy (S, 2, Length (S) - 1);
  If X < 0 then S := '-' + S;
  LongStr2 := S
End;

Procedure Color (B, T : Byte);
Begin
  If Seg(GetScreenPtr^)=$B000 then
    Begin
      Case B of
        Blue  : B := Black;
        Green : Begin B := Black; T := LightGray End;
      End;
      Case T of
        Red       : T := Black;
        LightCyan : T := LightGray;
        Yellow    : T := White;
      End;
    End;
  TextColor (T);
  TextBackGround (B)
End;

Function UpStr (S : String) : String;
Var
  I  : Byte;
  St : String;
Begin
  St := S;
  For I := 1 to Length (S) do
    St[I] := UpCase (S[I]);
  UpStr := St
End;

Function CD (P : PathStr) : Boolean;
Begin
  {$I-}
  If Length (P) = 3 then ChDir (P)
  Else ChDir (Copy (P, 1, Length(P)-1));
  {$I+}
  CD := IOResult = 0
End;

Function FN (Name : String; Dir : Boolean) : String;
Var
  DS : DirStr;
  NS : NameStr;
  ES : ExtStr;
  S  : String;
  I  : Byte;
Begin
  FSplit (Name, DS, NS, ES);
  If Name <> '..' then
    Begin
      S := NS; While Length (S) < 9 do S := S+' ';
      S := S+Copy(ES,2,3)
    End
  Else S := Name;
  While Length (S) < 12 do S := S+' ';
  If not Dir then
    For I := 1 to Length (S) do
      If S[I] in ['A'..'Z'] then S[I] := Chr (Ord (S[I]) + 32);
  FN := S
End;

Function FNH (Name : String; Dir, Hid : Boolean) : String;
Var
  DS : DirStr;
  NS : NameStr;
  ES : ExtStr;
  S  : String;
  I  : Byte;
Begin
  If not Dir then
    For I := 1 to Length (Name) do
      If Name[I] in ['A'..'Z'] then Inc(Byte(Name[I]),32);
  FSplit (Name, DS, NS, ES);
  ES := Copy (ES, 2, 3);
  If Name <> '..' then
    Begin
      S := NS; While S[0] < #9 do S := S+' ';
      S := S+ES
    End
  Else S := Name;
  While S[0] < #12 do S := S+' ';
  If Hid then S[9] := '';
  FNH := S
End;

Function FDN (D : String) : String;
Var
  S : String;
Begin
  S := Copy (D,1,Length (D)-1);
  While S[Length(S)] <> '\' do S := Copy (S,1,Length(S)-1);
  FDN := S;
End;

Function Last (D : String) : String;
Var
  S : String;
Begin
  S := Copy (D, Length(FDN(D))+1, Length(D)-Length(FDN(D))-1);
  Last := S
End;

Function Exists (Name : PathStr) : Boolean;
Var F : File;
Begin
  Assign (F, Name);
  {$I-}
  Reset (F, 1);
  {$I+}
  If IOResult = 0 then
    Begin
      Close (F);
      Exists := True
    End
  Else Exists := False
End;

Function ReadScan : Byte;
Var R : Registers;
Begin
  R.AH := $01;
  Intr ($16, R);
  ReadScan := R.AH
End;

Function CMask (Mask, Name : String) : Boolean;
Var
  I, N : Byte;
  ME, NE,
  MN, NN : String;
  P : Boolean;
Label
  L1, L2, L3;
Begin
  P := False;
  If Pos ('.', Name) = 0 then Name := Name+'.';
  If Pos ('.', Mask) = 0 then Mask := Mask+'.';
  MN := Copy (Mask, 1, Pos ('.', Mask) - 1);
  NN := Copy (Name, 1, Pos ('.', Name) - 1);
  ME := Copy (Mask, Pos ('.', Mask), Length (Mask) - Length (MN));
  NE := Copy (Name, Pos ('.', Name), Length (Name) - Length (NN));
  If (ME=NE) or (ME[1] = '*') then Goto L1;
  If Length (ME) > Length (NE) then N := Length (NE)
  Else N := Length (ME);
  If Pos ('?', ME) > 0 then
    For I := 1 to N do
      If ME[I] = '?' then ME[I] := NE[I];
  If ME = NE then Goto L1;
  If Pos ('*', ME) > 0 then
    Begin
      ME := Copy (ME, 1, Pos ('*', ME) - 1);
      If ME = NE then Goto L1;
      If Length (ME) >= Length (NE) then Goto L3;
      Repeat
        ME := ME + NE[Length(ME)+1]
      Until Length (ME) = Length (NE);
      If ME = NE then Goto L1;
    End;
  Goto L3;
L1:
  If Length (MN) > Length (NN) then N := Length (NN)
  Else N := Length (MN);
  If Pos ('?', MN) > 0 then
    For I := 1 to N do
      If MN[I] = '?' then MN[I] := NN[I];
  If MN = NN then Goto L2;
  If Pos ('*', MN) > 0 then
    Begin
      MN := Copy (MN, 1, Pos ('*', MN) - 1);
      If MN = NN then Goto L2;
      If Length (MN) >= Length (NN) then Goto L3;
      Repeat
        MN := MN + NN[Length(MN)+1]
      UntIl Length (MN) = Length (NN);
      If MN = NN then Goto L2;
    End;
  Goto L3;
L2:
  P := True;
L3:
  CMask := P
End;

End.
