Unit Text_Abs;

Interface

Const
  Black         = 0;
  Blue          = 1;
  Green         = 2;
  Cyan          = 3;
  Red           = 4;
  Magenta       = 5;
  Brown         = 6;
  LightGray     = 7;
  DarkGray      = 8;
  LightBlue     = 9;
  LightGreen    = 10;
  LightCyan     = 11;
  LightRed      = 12;
  LightMagenta  = 13;
  Yellow        = 14;
  White         = 15;

Var
  TAX, TAY,
  TATextColor,
  TABackColor : Byte;

Procedure TAGotoXY (X, Y : Byte);

Procedure TAWriteChar (C : Char);

Procedure TAWriteString (St : String);

Procedure TAColor (Back, Text : Byte);

Function TAReadXY (X, Y : Byte) : Word;

Procedure TAWriteXY (X, Y : Byte; W : Word);

Implementation

Uses
  ProfText;

Procedure TAGotoXY (X, Y : Byte);
Begin
  TAX := X; TAY := Y
End;

Procedure TAWriteChar (C : Char);
Var
  Segment, Offset : Word;
Begin
  Segment := Seg (GetScreenPtr^);
  Offset := Ofs (GetScreenPtr^);
  Inc (Offset, (TAX-1)*2);
  Inc (Offset, (TAY-1)*GetColNum*2);
  Char(Mem[Segment:Offset]) := C;
  Inc (Offset);
  Mem[Segment:Offset] := TABackColor*16+TATextColor;
  Inc (Offset);
  TAY := (Offset-Ofs(GetScreenPtr^)) div (2*GetColNum);
  TAX := ((Offset-Ofs(GetScreenPtr^)) - TAY*GetColNum*2) div 2;
  Inc (TAY);
  Inc (TAX)
End;

Procedure TAWriteString (St : String);
Var
  Segment, Offset : Word;
  Count : Byte;
Begin
  If St[0] = #0 then Exit;
  Segment := Seg (GetScreenPtr^);
  Offset := Ofs (GetScreenPtr^);
  Inc (Offset, (TAX-1)*2);
  Inc (Offset, (TAY-1)*GetColNum*2);
  For Count := 1 to Byte(St[0]) do
    Begin
      Char(Mem[Segment:Offset]) := St[Count];
      Inc (Offset);
      Mem[Segment:Offset] := TABackColor*16+TATextColor;
      Inc (Offset)
    End;
  TAY := (Offset-Ofs(GetScreenPtr^)) div (2*GetColNum);
  TAX := ((Offset-Ofs(GetScreenPtr^)) - TAY*GetColNum*2) div 2;
  Inc (TAY);
  Inc (TAX)
End;

Procedure TAColor (Back, Text : Byte);
Begin
  TABackColor := Back;
  TATextColor := Text
End;

Function TAReadXY (X, Y : Byte) : Word;
Var
  Segment, Offset : Word;
Begin
  Segment := Seg (GetScreenPtr^);
  Offset := Ofs (GetScreenPtr^);
  Inc (Offset, (X-1)*2);
  Inc (Offset, (Y-1)*GetColNum*2);
  TAReadXY := Byte(Mem[Segment:Offset])+256*Byte(Mem[Segment:Offset+1])
End;

Procedure TAWriteXY (X, Y : Byte; W : Word);
Var
  Segment, Offset : Word;
Begin
  Segment := Seg (GetScreenPtr^);
  Offset := Ofs (GetScreenPtr^);
  Inc (Offset, (X-1)*2);
  Inc (Offset, (Y-1)*GetColNum*2);
  Byte(Mem[Segment:Offset]) := Lo(W);
  Byte(Mem[Segment:Offset+1]) := Hi(W)
End;

End.
